#include "aitextgeneratedpic.h"
#include <QDebug>

AITextGeneratedPic::AITextGeneratedPic()
{
    quantityNum = 1;
    multipleNum = 1;
    AIImageSize = QSize(640, 360);

    m_AiMode = new AIModeDataThread();
    connect(m_AiMode, &AIModeDataThread::finishedSignal, this, &AITextGeneratedPic::onThreadFinished);
}

AITextGeneratedPic::~AITextGeneratedPic()
{

}

void AITextGeneratedPic::wordInformationProcessing(QString message)
{
    quantityNum = 1;
    multipleNum = 1;
    AIImageSize = QSize(512, 512);
    textBox = message;

    for(int i = 0; i < quantityString.size(); ++i){
        const QString &keyword = quantityString.at(i);
        int index = message.indexOf(keyword);
        if (index != -1){
            qDebug()<<"数量：quantityString:  index = "<<index<<"keyword = "<<keyword<<" i = "<<i;
            if (i == 0 || i == 4 || i == 8 || i == 12)
                quantityNum = 1;
            else if (i == 1 || i == 5 || i == 9 || i == 13)
                quantityNum = 2;
            else if (i == 2 || i == 6 || i == 10 || i == 14)
                quantityNum = 4;
            else if (i == 3 || i == 7 || i == 11 || i == 15)
                quantityNum = 8;
            else
                quantityNum = 1;
            break;
        }
    }


    for(int i = 0; i < shapeString.size(); ++i){
        const QString &keyword = shapeString.at(i);
        int index = message.indexOf(keyword);
        if (index != -1) {
            qDebug()<<"比例：shapeString:  index = "<<index<<"keyword = "<<keyword<<" i = "<<i;
            if (i == 0 || i == 2 || i == 5)
                AIImageSize = QSize(640, 360);
            else if (i == 1 || i == 3 || i == 6)
                AIImageSize = QSize(512, 512);
            else if (i == 4 || i == 7)
                AIImageSize = QSize(360, 640);
            else
                AIImageSize = QSize(640, 360);
            break;
        }
    }
    //判断高清
//    for(int i = 0; i < pixelString.size(); ++i) {
//        const QString &keyword = pixelString.at(i);
//        int index = message.indexOf(keyword);
//        if (index != -1){
//            qDebug()<<"尺寸：pixelString:  index = "<<index<<"keyword = "<<keyword<<" i = "<<i;
//            if (i == 0 || i == 3)
//                multipleNum = 1;
//            else if (i == 1 || i == 4)
//                multipleNum = 2;
//            else if (i == 2 || i == 5)
//                multipleNum = 4;
//            else
//                multipleNum = 1;
//            break;
//        }
//    }
//    AIImageSize = AIImageSize * multipleNum;

    //目前只支持512 * 512
    AIImageSize = AIImageSize * multipleNum;

    //目前只实现一张生成，后续可以多张将以下删除就可
    quantityNum = 1;

    qDebug()<<"数量："<<quantityNum<<"尺寸："<<AIImageSize<<"内容: "<<textBox;
    startThread();
}

bool AITextGeneratedPic::getWhetherToDrawForAI(QString message)
{
    bool wordFlag = false;
    for(const QString &keyword : wordJudgment){
        int index = message.indexOf(keyword);
        if (index != -1){
            wordFlag = true;
        }
//        qDebug()<<"index ===== "<<index << keyword;
    }

    if(!wordFlag)
        return false;

    wordFlag = false;
    //只支持一张
//    for(const QString &keyword : quantityString){
//        if (message.indexOf(keyword) != -1){
//            for(const QString &keyword : mainFont){
//                int index = message.indexOf(keyword);
//                if (index != -1){
//                    wordFlag = true;
//                    break;
//                }
//            }
//            break;
//        }
//    }
    for(const QString &keyword : mainFont){
        int index = message.indexOf(keyword);
        if (index != -1){
            wordFlag = true;
            break;
        }
    }


    if(!wordFlag)
        return false;

//    wordInformationProcessing(message);
    return true;
}

/**
 * @brief AITextGeneratedPic::AIGeneratesErrorHandling
 * 生成图片报错处理
 * @param errorCode
 * @return
 */
QString AITextGeneratedPic::AIGeneratesErrorHandling(int errorCode)
{
    VisionResult visionError = (VisionResult)errorCode;
    QString errorMessage;

    switch (visionError) {
    case VISION_SESSION_ERROR:
    case VISION_GENERATE_IMAGE_FAILED:
        errorMessage = QString("生成错误");
        break;
    case VISION_GENERATE_IMAGE_BLOCKED:
        errorMessage = QString("文本或风格错误");
        break;
    case VISION_NET_ERROR:
        errorMessage = QString("网络错误");
        break;
    case VISION_SERVER_ERROR:
        errorMessage = QString("服务错误");
        break;
    case VISION_UNAUTHORIZED:
        errorMessage = QString("未配置视觉模型");
        break;
    case VISION_REQUEST_FAILED:
        errorMessage = QString("请求失败");
        break;
    case VISION_TASK_TIMEOUT:
        errorMessage = QString("任务超时");
        break;
    case VISION_INPUT_TEXT_LENGTH_INVAILD:
    case VISION_PARAM_ERROR:
        errorMessage = QString("文本长度超限");
        break;
//    case VISION_PARAM_ERROR:
//        map = QString("参数错误");
//        break;
    default:
        errorMessage = QString("生成错误");
        break;
    }
    return errorMessage;

}

/**
 * @brief AITextGeneratedPic::onThreadFinished
 * AI生成后，线程的回调函数
 * @param flag
 * @param pixmap
 * @param imageIndex
 * @param imageSum
 * @param errorCode
 */
void AITextGeneratedPic::onThreadFinished(VisionImageData *imageData, int errorCode)
{
    // 可以调用主进程的函数等
    if (errorCode != 0){
        qDebug()<<"出错";
        QString errorMessage = AIGeneratesErrorHandling(errorCode);
        emit pictureUpdateSignal(nullptr, errorMessage);
        return;
    }
    emit pictureUpdateSignal(imageData, "");
}

AIModeDataThread::AIModeDataThread()
{

}

AIModeDataThread::~AIModeDataThread()
{
    vision_destory_session(session);
}

bool AIModeDataThread::setSessionStatus()
{
    if (m_sessionFlag)
        return true;

    session = nullptr;
    VisionResult ret = vision_create_session(&session);
    if (ret != VISION_SUCCESS) {
        qDebug()<<"创建失败VisionResult="<<ret
                <<"ErrorMessage:"<<vision_get_last_error_message();
        sendErrorSignal(ret);
        m_sessionFlag = false;
        return false;
    }

    VisionResult initRet = vision_init_session(session);
    if (initRet != VISION_SUCCESS) {
        qDebug()<<"初始化失败 VisionResult="<<initRet
                <<"ErrorMessage:"<<vision_get_last_error_message();
        sendErrorSignal(initRet);
        m_sessionFlag = false;
        return false;
    }
    m_sessionFlag = true;
    return true;
}

/**
 * @brief AIModeDataThread::someFunctionInThread
 * AI服务调用函数
 * @return
 */
bool AIModeDataThread::someFunctionInThread()
{
    int width = AIImageSize.width();
    int height = AIImageSize.height();

    vision_set_prompt2image_number(session, quantityNum);
    vision_set_prompt2image_size(session, width, height);
    vision_set_prompt2image_callback(session, generateImageCallback, this);
//    vision_set_prompt2image_style(session, ImageStyle);

    VisionResult imageRet = vision_prompt2image_async(session, textBox.toLocal8Bit().data());

    if (imageRet != VISION_SUCCESS) {
        qDebug()<<"文字输入失败,VisionResult="<<imageRet
                <<"ErrorMessage:"<<vision_get_last_error_message();
        sendErrorSignal(imageRet);
        return false;
    }

    return true;
}

/**
 * @brief AIModeDataThread::generateImageCallback
 * AI生成后回调函数
 * @param imageData
 * @param userData
 */
void AIModeDataThread::generateImageCallback(VisionImageData imageData, void* userData){

    AIModeDataThread *AIMode = (AIModeDataThread *)userData;

//    map.loadFromData(imageData.data, imageData.data_size);

    emit AIMode->finishedSignal(&imageData, imageData.error_code);
}
