#include "kwebengineview.h"

#include <QMimeData>
#include <QDebug>
#include <QFile>
#include <QDataStream>
#include <QFileInfo>

KWebEngineView::KWebEngineView(QWidget *parent)
    : QWebEngineView(parent)
{

}

void KWebEngineView::dragEnterEvent(QDragEnterEvent *event)
{
    //所有图片格式
    QStringList formatList = {"tga", "svg", "gif", "apng", "ico", "xpm",
                              "exr", "psd", "jfi", "jif", "j2k", "jp2", "jng", "wbmp", "xbm", "tiff", "tif", "webp",
                              "pnm", "bmp", "dib", "sr",  "ras", "pbm", "pgm", "ppm",  "png", "jpg",  "jpe", "jpeg"};

    //检查当前拖入的否为url，暂时只支持以url形式拖入
    if (!event->mimeData()->hasUrls()) {
        return;
    }

    //极端情况下，拖拽文件时list有可能为空，不做异常处理时，会闪退。
    QList<QUrl> list = event->mimeData()->urls();
    if (list.isEmpty()) {
        return;
    }
    QUrl url = list.first();
    if (url.isEmpty()) {
        return;
    }
    QString str = url.fileName();
    if (str.isEmpty()) {
        return;
    }
    //判断是否为图片
    if (formatList.contains(QFileInfo(str).suffix().toLower())) {
        event->acceptProposedAction();
    } else {
        event->ignore(); //否则不接受鼠标事件
    }
}

void KWebEngineView::dropEvent(QDropEvent *event)
{
    QList<QUrl> urls = event->mimeData()->urls();
    //判断是否为空
    if (urls.isEmpty()) {
        return;
    }
    //拿路径，发信号打开图片
    QString path = urls.first().toLocalFile();
    if (path == "") {
        return;
    }

    emit sigShowImage(path);
    event->acceptProposedAction();
}
