QT       += core gui webenginewidgets sql dbus multimedia websockets webchannel x11extras
#QT       += core gui webenginewidgets sql dbus multimedia websockets webchannel x11extras svg

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

CONFIG += c++11 link_pkgconfig
#CONFIG += c++17 link_pkgconfig

PKGCONFIG += gsettings-qt kysdk-qtwidgets glib-2.0 kysdk-datacollect
#PKGCONFIG += gsettings-qt kysdk-qtwidgets glib-2.0 librsvg-2.0

# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

INCLUDEPATH += /usr/include/KF5/KWindowSystem/

LIBS += -lukui-log4qt -lkylin-ai-base -lKF5WindowSystem -lKF5Screen -lkysdk-qtwidgets -lkysdk-kabase -lX11 -lXtst

##opencv
#INCLUDEPATH += /usr/include/opencv4/
#LIBS += -lopencv_core \
#        -lopencv_highgui \
#        -lopencv_imgcodecs \
#        -lopencv_imgproc \
#        -lopencv_dnn \

##onnxruntime
#INCLUDEPATH += /usr/include/onnxruntime
#LIBS += -L/usr/lib -lonnxruntime

##抠图插件
#LIBS += -lphoto-viewer-aiassistant-plugin
#INCLUDEPATH += /usr/include/kylin_image_codec/

TRANSLATIONS = translations/Internationalization_zh_CN.ts

# Generate translations in build
TRANSLATIONS_FILES =

qtPrepareTool(LRELEASE, lrelease)
for(tsfile, TRANSLATIONS) {
    qmfile = $$shadowed($$tsfile)
    qmfile ~= s,.ts$,.qm,
    qmdir = $$dirname(qmfile)
    !exists($$qmdir) {
        mkpath($$qmdir)|error("Aborting.")
    }
    command = $$LRELEASE -removeidentical $$tsfile -qm $$qmfile
    system($$command)|error("Failed to run: $$command")
    TRANSLATIONS_FILES += $$qmfile
}

include(libukcc/widgets.pri)

SOURCES += \
    aitextgeneratedpic.cpp \
    audiorecinfo.cpp \
    channelmessage.cpp \
    cmainwnd.cpp \
    chatdatabase.cpp \
    chatoperator.cpp \
    cpushbuttonex.cpp \
    ctextedit.cpp \
    ctrl.cpp \
    dbus/kadbusoperator.cpp \
    global/kaglobal.cpp \
    historyitemwidget.cpp \
    kasendbar.cpp \
    kwebengineview.cpp \
    main.cpp \
    meetingrecorder.cpp \
    msgpane.cpp \
    reader.cpp \
    recorder.cpp \
    renamedialog.cpp \
    runtimerecorder.cpp \
    searchlineedit.cpp \
    setting/kaconventionpage.cpp \
    setting/kafloatingbarpage.cpp \
    setting/kainstructionpage.cpp \
    setting/kamodelitem.cpp \
    setting/kamodelsettingpage.cpp \
    setting/kamultimodelsettingpage.cpp \
    setting/kasettingdialog.cpp \
    setting/modelcardwidget.cpp \
    textselect/clipboard.cpp \
    textselect/mydialog.cpp \
    textselect/mypushbutton.cpp \
    textselect/selection.cpp \
    setting/templatebutton.cpp \
    sidebarwidget.cpp \
    startuptools.cpp \
    tipwidget.cpp \
    xeventmonitor.cpp

HEADERS += \
    aitextgeneratedpic.h \
    audiorecinfo.h \
    channelmessage.h \
    cmainwnd.h \
    chatdatabase.h \
    chatoperator.h \
    cpushbuttonex.h \
    ctextedit.h \
    ctrl.h \
    dbus/kadbusoperator.h \
    global/kaglobal.h \
    historyitemwidget.h \
    kasendbar.h \
    kwebengineview.h \
    meetingrecorder.h \
    msgpane.h \
    reader.h \
    recorder.h \
    renamedialog.h \
    runtimerecorder.h \
    searchlineedit.h \
    setting/kaconventionpage.h \
    setting/kafloatingbarpage.h \
    setting/kainstructionpage.h \
    setting/kamodelitem.h \
    setting/kamodelsettingpage.h \
    setting/kamultimodelsettingpage.h \
    setting/kasettingdialog.h \
    setting/modelcardwidget.h \
    textselect/clipboard.h \
    textselect/mydialog.h \
    textselect/mypushbutton.h \
    textselect/selection.h \
    setting/templatebutton.h \
    sidebarwidget.h \
    startuptools.h \
    tipwidget.h \
    usdbrightness.h \
    xeventmonitor.h

RESOURCES += \
    res/msgpane.qrc
CONFIG += link_pkgconfig
PKGCONFIG +=  kysdk-qtwidgets  kysdk-waylandhelper

TARGET = kylin-aiassistant
TEMPLATE = app

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

# installs
unix:!macx {
    isEmpty(PREFIX) {
      packaging {
        PREFIX = /usr
      } else {
        PREFIX = /usr/local
      }
    }

    DEFINES += APP_PREFIX=\\\"$$PREFIX\\\"

    target.path = $${PREFIX}/bin/

    qmfile.path = $${PREFIX}/share/kylin-aiassistant/translations/
    qmfile.files = $${TRANSLATIONS_FILES}

    desktopentry.path = $${PREFIX}/share/applications
    desktopentry.files = kylin-aiassistant.desktop

    autuostart.files = kylin-aiassistant-autostart.desktop
    autuostart.path = /etc/xdg/autostart/

    schemas.files = data/org.kylin.aiassistant.gschema.xml
    schemas.path = /usr/share/glib-2.0/schemas

    service.files = data/com.kylin.aiassistant.service
    service.path = /usr/share/dbus-1/services

    icon.path = /usr/share/pixmaps
    icon.files = res/icon/AI-Writing.svg

    INSTALLS += target qmfile desktopentry schemas service icon autuostart
}


