#ifndef KAMODELITEM_H
#define KAMODELITEM_H

#include <memory>
#include <QWidget>
#include <QGSettings>
#include <QMouseEvent>

#include <kylin-ai/ai-base/modelconfig.h>

#define THEME_QT_SCHEMA  "org.ukui.style"

using namespace std;

typedef enum { NLP_TYPE, VISION_TYPE, SPEECH_TYPE} ModelTypeId;
typedef enum { BAIDU_TYPE, XUNFEI_TYPE} ModelVendorId;

class KAModelItem : public QWidget
{
    Q_OBJECT
public:
    explicit KAModelItem(ModelTypeId modelTypeId, ModelVendorId modelVendorId, QWidget *parent = nullptr);
    ~KAModelItem();

    void showSelectedIcon(bool flag);
    bool isSelected();
    ModelTypeId getModelTypeId();
    ModelVendorId getModelVendorId();

signals:
    void sigEdit(ModelTypeId modelTypeId, ModelVendorId modelVendorId);
    void sigDelete(ModelTypeId modelTypeId, ModelVendorId modelVendorId);
    void sigClicked(ModelTypeId modelTypeId, ModelVendorId modelVendorId);

private slots:

private:
    void initLayout();
    void initMenu();

private:
    class Private;
    shared_ptr<Private> d_ptr;
};

#endif // KAMODELITEM_H
