#ifndef MODELCARDWIDGET_H
#define MODELCARDWIDGET_H

#include <QWidget>
#include <QLabel>
#include <QPixmap>
#include <QMouseEvent>
#include <QPainter>
#include <QEvent>
#include <QLabel>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QPalette>
#include <QGSettings>

#include "kcolorbutton.h"
using namespace kdk;
#define PX_16 16
#define PX_14 14
#define PX_20 20

#define UKUI_FONT_SIZE "systemFontSize"

class ModelCardWidget : public QWidget
{
    Q_OBJECT

public:
    ModelCardWidget(const QString &modelName, const QPixmap &modelImage, bool defaultState, QWidget *parent = nullptr);
    ~ModelCardWidget();

    void changeTheme();

protected:
    bool eventFilter(QObject *watched, QEvent *event) override;

public Q_SLOTS:
    void slotLabelSetFontSize(int size);

signals:
    void clickCard();

private:
    bool m_state;

    QString m_modelName;
    QPixmap m_modelIcon;
    QLabel *m_iconLabel;
    QLabel *m_nameLabel;
    QLabel *m_selectIconLabel;
    QVBoxLayout *m_vLayout = nullptr;

    void initConnect();

};

#endif // MODELCARDWIDGET_H

