#include "templatebutton.h"

#include <QLabel>
#include <QHBoxLayout>

// #include "kborderlessbutton.h"

// using namespace kdk;

class TemplateButton::Private
{
public:
    QLabel *m_textLabel = nullptr;
};

TemplateButton::TemplateButton(const QString& text, QWidget *parent)
    :  QPushButton{parent},
      d_ptr(make_shared<Private>())
{
    setText(text);
    initStyle();
    this->setFixedSize(86, 28);
    QFont font("Noto Sans CJK SC", 14, QFont::Normal, false);
    font.setPixelSize(14);
    this->setFont(font);
}

TemplateButton::~TemplateButton()
{

}

void TemplateButton::updateButton()
{
    QString buttonText = text();
    int textWidth = fontMetrics().horizontalAdvance(buttonText);
    setFixedWidth(textWidth + 20);
}
void TemplateButton::initStyle()
{
    setStyleSheet("QPushButton {"
                  "padding: 4px 0px 4px 0px;"
                  "border-radius: 4px;"
                  "background: rgba(55, 144, 250, 0.1);"
                  "color: rgba(55, 144, 250, 1);"
                  "}");

    return;
}
