#include "clipboard.h"

#include <QClipboard>
#include <QApplication>
#include <QDebug>
#include "global/kaglobal.h"

Clipboard::Clipboard(QObject *parent) : QObject(parent)
{
    QClipboard *selectClip = QApplication::clipboard();
    connect(selectClip, &QClipboard::selectionChanged, [selectClip, this]() {
        clipText = selectClip->text(QClipboard::Mode::Selection);
        if(!scribeWordsDisabled
            && !clipText.trimmed().isEmpty()
            && g_gsettings->get("is-stroke-word").toBool())
        {
           emit selectWords();
        }
    });
}

QString Clipboard::getClipText()
{
    return clipText;
}

void Clipboard::onScribeWordsDisabled()
{
    scribeWordsDisabled = true;
}

void Clipboard::onScribeWordsIsabled()
{
    scribeWordsDisabled = false;
}
